Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class Thread

    java.lang.Object
      |
      +--java.lang.Thread

All Implemented Interfaces:
  Runnable

public class Thread
extends Object
implements Runnable

A thread is a thread of execution in a program. The Java Virtual Machine allows an application to have multiple threads of execution running concurrently.

Every thread has a priority. Threads with higher priority are executed in preference to threads with lower priority. Each thread may or may not also be marked as a daemon. When code running in some thread creates a new `Thread` object, the new thread has its priority initially set equal to the priority of the creating thread, and is a daemon thread if and only if the creating thread is a daemon.

When a Java Virtual Machine starts up, there is usually a single non-daemon thread (which typically calls the method named `main` of some designated class). The Java Virtual Machine continues to execute threads until either of the following occurs:

- The `exit` method of class `Runtime` has been called and the security manager has permitted the exit operation to take place.
- All threads that are not daemon threads have died, either by returning from the call to the `run` method or by throwing an exception that propagates beyond the `run` method.

There are two ways to create a new thread of execution. One is to declare a class to be a subclass of `Thread`. This subclass should override the `run` method of class `Thread`. An instance of the subclass can then be allocated and started. For example, a thread that computes primes larger than a stated value could be written as follows:

>          class PrimeThread extends Thread {
>              long minPrime;
>              PrimeThread(long minPrime) {
>                  this.minPrime = minPrime;
>              }

>              public void run() {
>                  // compute primes larger than minPrime
>                   . . .
>              }
>          }

The following code would then create a thread and start it running:

>          PrimeThread p = new PrimeThread(143);
>          p.start();

The other way to create a thread is to declare a class that implements the `Runnable` interface. That class then implements the `run` method. An instance of the class can then be allocated, passed as an argument when creating `Thread`, and started. The same example in this other style looks like the following:

>          class PrimeRun implements Runnable {
>              long minPrime;
>              PrimeRun(long minPrime) {
>                  this.minPrime = minPrime;
>              }

>              public void run() {
>                  // compute primes larger than minPrime
>                   . . .
>              }
>          }

The following code would then create a thread and start it running:

>          PrimeRun p = new PrimeRun(143);
>          new Thread(p).start();

Every thread has a name for identification purposes. More than one thread may have the same name. If a name is not specified when a thread is created, a new name is generated for it.

Since:
  JDK1.0
See Also:
  `Runnable`, `Runtime.exit(int)`, `run()`, `stop()`

Field Summary
`static int` | `MAX_PRIORITY` The maximum priority that a thread can have.
`static int` | `MIN_PRIORITY` The minimum priority that a thread can have.
`static int` | `NORM_PRIORITY` The default priority that is assigned to a thread.

Constructor Summary
`Thread()` Allocates a new `Thread` object.
`Thread(Runnable target)` Allocates a new `Thread` object.
`Thread(Runnable target, String name)` Allocates a new `Thread` object.
`Thread(String name)` Allocates a new `Thread` object.
`Thread(ThreadGroup group, Runnable target)` Allocates a new `Thread` object.
`Thread(ThreadGroup group, Runnable target, String name)` Allocates a new `Thread` object so that it has `target` as its run object, has the specified `name` as its name, and belongs to the thread group referred to by `group`.
`Thread(ThreadGroup group, Runnable target, String name, long stackSize)` Allocates a new `Thread` object so that it has `target` as its run object, has the specified `name` as its name, belongs to the thread group referred to by `group`, and has the specified stack size.
`Thread(ThreadGroup group, String name)` Allocates a new `Thread` object.

Method Summary
`static int` | `activeCount()` Returns the number of active threads in the current thread's thread group.
`void` | `checkAccess()` Determines if the currently running thread has permission to modify this thread.
`int` | `countStackFrames()` Deprecated. The definition of this call depends on `suspend()`, which is deprecated. Further, the results of this call were never well-defined.
`static Thread` | `currentThread()` Returns a reference to the currently executing thread object.
`void` | `destroy()` Destroys this thread, without any cleanup.
`static void` | `dumpStack()` Prints a stack trace of the current thread.
`static int` | `enumerate(Thread[] tarray)` Copies into the specified array every active thread in the current thread's thread group and its subgroups.
`ClassLoader` | `getContextClassLoader()` Returns the context ClassLoader for this Thread.
`String` | `getName()` Returns this thread's name.
`int` | `getPriority()` Returns this thread's priority.
`ThreadGroup` | `getThreadGroup()` Returns the thread group to which this thread belongs.
`static boolean` | `holdsLock(Object obj)` Returns `true` if and only if the current thread holds the monitor lock on the specified object.
`void` | `interrupt()` Interrupts this thread.
`static boolean` | `interrupted()` Tests whether the current thread has been interrupted.
`boolean` | `isAlive()` Tests if this thread is alive.
`boolean` | `isDaemon()` Tests if this thread is a daemon thread.
`boolean` | `isInterrupted()` Tests whether this thread has been interrupted.
`void` | `join()` Waits for this thread to die.
`void` | `join(long millis)` Waits at most `millis` milliseconds for this thread to die.
`void` | `join(long millis, int nanos)` Waits at most `millis` milliseconds plus `nanos` nanoseconds for this thread to die.
`void` | `resume()` Deprecated. This method exists solely for use with `suspend()`, which has been deprecated because it is deadlock-prone. For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.
`void` | `run()` If this thread was constructed using a separate `Runnable` run object, then that `Runnable` object's `run` method is called; otherwise, this method does nothing and returns.
`void` | `setContextClassLoader(ClassLoader cl)` Sets the context ClassLoader for this Thread.
`void` | `setDaemon(boolean on)` Marks this thread as either a daemon thread or a user thread.
`void` | `setName(String name)` Changes the name of this thread to be equal to the argument `name`.
`void` | `setPriority(int newPriority)` Changes the priority of this thread.
`static void` | `sleep(long millis)` Causes the currently executing thread to sleep (temporarily cease execution) for the specified number of milliseconds.
`static void` | `sleep(long millis, int nanos)` Causes the currently executing thread to sleep (cease execution) for the specified number of milliseconds plus the specified number of nanoseconds.
`void` | `start()` Causes this thread to begin execution; the Java Virtual Machine calls the `run` method of this thread.
`void` | `stop()` Deprecated. This method is inherently unsafe. Stopping a thread with Thread.stop causes it to unlock all of the monitors that it has locked (as a natural consequence of the unchecked `ThreadDeath` exception propagating up the stack). If any of the objects previously protected by these monitors were in an inconsistent state, the damaged objects become visible to other threads, potentially resulting in arbitrary behavior. Many uses of `stop` should be replaced by code that simply modifies some variable to indicate that the target thread should stop running. The target thread should check this variable regularly, and return from its run method in an orderly fashion if the variable indicates that it is to stop running. If the target thread waits for long periods (on a condition variable, for example), the `interrupt` method should be used to interrupt the wait. For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.
`void` | `stop(Throwable obj)` Deprecated. This method is inherently unsafe. See `stop()` (with no arguments) for details. An additional danger of this method is that it may be used to generate exceptions that the target thread is unprepared to handle (including checked exceptions that the thread could not possibly throw, were it not for this method). For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.
`void` | `suspend()` Deprecated. This method has been deprecated, as it is inherently deadlock-prone. If the target thread holds a lock on the monitor protecting a critical system resource when it is suspended, no thread can access this resource until the target thread is resumed. If the thread that would resume the target thread attempts to lock this monitor prior to calling `resume`, deadlock results. Such deadlocks typically manifest themselves as "frozen" processes. For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.
`String` | `toString()` Returns a string representation of this thread, including the thread's name, priority, and thread group.
`static void` | `yield()` Causes the currently executing thread object to temporarily pause and allow other threads to execute.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### MIN_PRIORITY

    public static final int MIN_PRIORITY

  The minimum priority that a thread can have.

  See Also:
    Constant Field Values

### NORM_PRIORITY

    public static final int NORM_PRIORITY

  The default priority that is assigned to a thread.

  See Also:
    Constant Field Values

### MAX_PRIORITY

    public static final int MAX_PRIORITY

  The maximum priority that a thread can have.

  See Also:
    Constant Field Values

Constructor Detail

### Thread

    public Thread()

  Allocates a new `Thread` object. This constructor has the same effect as `Thread(null, null,` gname`)`, where gname is a newly generated name. Automatically generated names are of the form `"Thread-"+`n, where n is an integer.

See Also:
  `Thread(java.lang.ThreadGroup, java.lang.Runnable, java.lang.String)`

### Thread

    public Thread(Runnable target)

  Allocates a new `Thread` object. This constructor has the same effect as `Thread(null, target,` gname`)`, where gname is a newly generated name. Automatically generated names are of the form `"Thread-"+`n, where n is an integer.

Parameters:
  `target` - the object whose `run` method is called.
See Also:
  `Thread(java.lang.ThreadGroup, java.lang.Runnable, java.lang.String)`

### Thread

    public Thread(ThreadGroup group,
                  Runnable target)

  Allocates a new `Thread` object. This constructor has the same effect as `Thread(group, target,` gname`)`, where gname is a newly generated name. Automatically generated names are of the form `"Thread-"+`n, where n is an integer.

Parameters:
  `group` - the thread group.
  `target` - the object whose `run` method is called.
Throws:
  `SecurityException` - if the current thread cannot create a thread in the specified thread group.
See Also:
  `Thread(java.lang.ThreadGroup, java.lang.Runnable, java.lang.String)`

### Thread

    public Thread(String name)

  Allocates a new `Thread` object. This constructor has the same effect as `Thread(null, null, name)`.

Parameters:
  `name` - the name of the new thread.
See Also:
  `Thread(java.lang.ThreadGroup, java.lang.Runnable, java.lang.String)`

### Thread

    public Thread(ThreadGroup group,
                  String name)

  Allocates a new `Thread` object. This constructor has the same effect as `Thread(group, null, name)`

Parameters:
  `group` - the thread group.
  `name` - the name of the new thread.
Throws:
  `SecurityException` - if the current thread cannot create a thread in the specified thread group.
See Also:
  `Thread(java.lang.ThreadGroup, java.lang.Runnable, java.lang.String)`

### Thread

    public Thread(Runnable target,
                  String name)

  Allocates a new `Thread` object. This constructor has the same effect as `Thread(null, target, name)`.

Parameters:
  `target` - the object whose `run` method is called.
  `name` - the name of the new thread.
See Also:
  `Thread(java.lang.ThreadGroup, java.lang.Runnable, java.lang.String)`

### Thread

    public Thread(ThreadGroup group,
                  Runnable target,
                  String name)

  Allocates a new `Thread` object so that it has `target` as its run object, has the specified `name` as its name, and belongs to the thread group referred to by `group`.

  If `group` is `null` and there is a security manager, the group is determined by the security manager's `getThreadGroup` method. If `group` is `null` and there is not a security manager, or the security manager's `getThreadGroup` method returns `null`, the group is set to be the same ThreadGroup as the thread that is creating the new thread.

  If there is a security manager, its `checkAccess` method is called with the ThreadGroup as its argument. This may result in a SecurityException.

  If the `target` argument is not `null`, the `run` method of the `target` is called when this thread is started. If the target argument is `null`, this thread's `run` method is called when this thread is started.

  The priority of the newly created thread is set equal to the priority of the thread creating it, that is, the currently running thread. The method `setPriority` may be used to change the priority to a new value.

  The newly created thread is initially marked as being a daemon thread if and only if the thread creating it is currently marked as a daemon thread. The method `setDaemon` may be used to change whether or not a thread is a daemon.

Parameters:
  `group` - the thread group.
  `target` - the object whose `run` method is called.
  `name` - the name of the new thread.
Throws:
  `SecurityException` - if the current thread cannot create a thread in the specified thread group.
See Also:
  `Runnable.run()`, `run()`, `setDaemon(boolean)`, `setPriority(int)`, `ThreadGroup.checkAccess()`, `SecurityManager.checkAccess(java.lang.Thread)`

### Thread

    public Thread(ThreadGroup group,
                  Runnable target,
                  String name,
                  long stackSize)

  Allocates a new `Thread` object so that it has `target` as its run object, has the specified `name` as its name, belongs to the thread group referred to by `group`, and has the specified stack size.

  This constructor is identical to `Thread(ThreadGroup,Runnable,String)` with the exception of the fact that it allows the thread stack size to be specified. The stack size is the approximate number of bytes of address space that the virtual machine is to allocate for this thread's stack. The effect of the `stackSize` parameter, if any, is highly platform dependent.

  On some platforms, specifying a higher value for the `stackSize` parameter may allow a thread to achieve greater recursion depth before throwing a `StackOverflowError`. Similarly, specifying a lower value may allow a greater number of threads to exist concurrently without throwing an an `OutOfMemoryError` (or other internal error). The details of the relationship between the value of the `stackSize` parameter and the maximum recursion depth and concurrency level are platform-dependent. On some platforms, the value of the `stackSize` parameter may have no effect whatsoever.

  The virtual machine is free to treat the `stackSize` parameter as a suggestion. If the specified value is unreasonably low for the platform, the virtual machine may instead use some platform-specific minimum value; if the specified value is unreasonably high, the virtual machine may instead use some platform-specific maximum. Likewise, the virtual machine is free to round the specified value up or down as it sees fit (or to ignore it completely).

  Specifying a value of zero for the `stackSize` parameter will cause this constructor to behave exactly like the `Thread(ThreadGroup, Runnable, String)` constructor.

  Due to the platform-dependent nature of the behavior of this constructor, extreme care should be exercised in its use. The thread stack size necessary to perform a given computation will likely vary from one JRE implementation to another. In light of this variation, careful tuning of the stack size parameter may be required, and the tuning may need to be repeated for each JRE implementation on which an application is to run.

  Implementation note: Java platform implementers are encouraged to document their implementation's behavior with respect to the `stackSize parameter`.

Parameters:
  `group` - the thread group.
  `target` - the object whose `run` method is called.
  `name` - the name of the new thread.
  `stackSize` - the desired stack size for the new thread, or zero to indicate that this parameter is to be ignored.
Throws:
  `SecurityException` - if the current thread cannot create a thread in the specified thread group.

Method Detail

### currentThread

    public static Thread currentThread()

  Returns a reference to the currently executing thread object.

  Returns:
    the currently executing thread.

### yield

    public static void yield()

  Causes the currently executing thread object to temporarily pause and allow other threads to execute.

### sleep

    public static void sleep(long millis)
                      throws InterruptedException

  Causes the currently executing thread to sleep (temporarily cease execution) for the specified number of milliseconds. The thread does not lose ownership of any monitors.

  Parameters:
    `millis` - the length of time to sleep in milliseconds.
  Throws:
    `InterruptedException` - if another thread has interrupted the current thread. The interrupted status of the current thread is cleared when this exception is thrown.
  See Also:
    `Object.notify()`

### sleep

    public static void sleep(long millis,
                             int nanos)
                      throws InterruptedException

  Causes the currently executing thread to sleep (cease execution) for the specified number of milliseconds plus the specified number of nanoseconds. The thread does not lose ownership of any monitors.

  Parameters:
    `millis` - the length of time to sleep in milliseconds.
    `nanos` - 0-999999 additional nanoseconds to sleep.
  Throws:
    `IllegalArgumentException` - if the value of millis is negative or the value of nanos is not in the range 0-999999.
    `InterruptedException` - if another thread has interrupted the current thread. The interrupted status of the current thread is cleared when this exception is thrown.
  See Also:
    `Object.notify()`

### start

    public void start()

  Causes this thread to begin execution; the Java Virtual Machine calls the `run` method of this thread.

  The result is that two threads are running concurrently: the current thread (which returns from the call to the `start` method) and the other thread (which executes its `run` method).

  Throws:
    `IllegalThreadStateException` - if the thread was already started.
  See Also:
    `run()`, `stop()`

### run

    public void run()

  If this thread was constructed using a separate `Runnable` run object, then that `Runnable` object's `run` method is called; otherwise, this method does nothing and returns.

  Subclasses of `Thread` should override this method.

  Specified by:
    `run` in interface `Runnable`
  See Also:
    `start()`, `stop()`, `Thread(java.lang.ThreadGroup, java.lang.Runnable, java.lang.String)`, `Runnable.run()`

### stop

    public final void stop()

  Deprecated. This method is inherently unsafe. Stopping a thread with Thread.stop causes it to unlock all of the monitors that it has locked (as a natural consequence of the unchecked `ThreadDeath` exception propagating up the stack). If any of the objects previously protected by these monitors were in an inconsistent state, the damaged objects become visible to other threads, potentially resulting in arbitrary behavior. Many uses of `stop` should be replaced by code that simply modifies some variable to indicate that the target thread should stop running. The target thread should check this variable regularly, and return from its run method in an orderly fashion if the variable indicates that it is to stop running. If the target thread waits for long periods (on a condition variable, for example), the `interrupt` method should be used to interrupt the wait. For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.

  Forces the thread to stop executing.

  If there is a security manager installed, its `checkAccess` method is called with `this` as its argument. This may result in a `SecurityException` being raised (in the current thread).

  If this thread is different from the current thread (that is, the current thread is trying to stop a thread other than itself), the security manager's `checkPermission` method (with a `RuntimePermission("stopThread")` argument) is called in addition. Again, this may result in throwing a `SecurityException` (in the current thread).

  The thread represented by this thread is forced to stop whatever it is doing abnormally and to throw a newly created `ThreadDeath` object as an exception.

  It is permitted to stop a thread that has not yet been started. If the thread is eventually started, it immediately terminates.

  An application should not normally try to catch `ThreadDeath` unless it must do some extraordinary cleanup operation (note that the throwing of `ThreadDeath` causes `finally` clauses of `try` statements to be executed before the thread officially dies). If a `catch` clause catches a `ThreadDeath` object, it is important to rethrow the object so that the thread actually dies.

  The top-level error handler that reacts to otherwise uncaught exceptions does not print out a message or otherwise notify the application if the uncaught exception is an instance of `ThreadDeath`.

  Throws:
    `SecurityException` - if the current thread cannot modify this thread.
  See Also:
    `interrupt()`, `checkAccess()`, `run()`, `start()`, `ThreadDeath`, `ThreadGroup.uncaughtException(java.lang.Thread, java.lang.Throwable)`, `SecurityManager.checkAccess(Thread)`, `SecurityManager.checkPermission(java.security.Permission)`

### stop

    public final void stop(Throwable obj)

  Deprecated. This method is inherently unsafe. See `stop()` (with no arguments) for details. An additional danger of this method is that it may be used to generate exceptions that the target thread is unprepared to handle (including checked exceptions that the thread could not possibly throw, were it not for this method). For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.

  Forces the thread to stop executing.

  If there is a security manager installed, the `checkAccess` method of this thread is called, which may result in a `SecurityException` being raised (in the current thread).

  If this thread is different from the current thread (that is, the current thread is trying to stop a thread other than itself) or `obj` is not an instance of `ThreadDeath`, the security manager's `checkPermission` method (with the `RuntimePermission("stopThread")` argument) is called in addition. Again, this may result in throwing a `SecurityException` (in the current thread).

  If the argument `obj` is null, a `NullPointerException` is thrown (in the current thread).

  The thread represented by this thread is forced to complete whatever it is doing abnormally and to throw the `Throwable` object `obj` as an exception. This is an unusual action to take; normally, the `stop` method that takes no arguments should be used.

  It is permitted to stop a thread that has not yet been started. If the thread is eventually started, it immediately terminates.

  Parameters:
    `obj` - the Throwable object to be thrown.
  Throws:
    `SecurityException` - if the current thread cannot modify this thread.
  See Also:
    `interrupt()`, `checkAccess()`, `run()`, `start()`, `stop()`, `SecurityManager.checkAccess(Thread)`, `SecurityManager.checkPermission(java.security.Permission)`

### interrupt

    public void interrupt()

  Interrupts this thread.

  First the `checkAccess` method of this thread is invoked, which may cause a `SecurityException` to be thrown.

  If this thread is blocked in an invocation of the `wait()`, `wait(long)`, or `wait(long, int)` methods of the `Object` class, or of the `join()`, `join(long)`, `join(long, int)`, `sleep(long)`, or `sleep(long, int)`, methods of this class, then its interrupt status will be cleared and it will receive an `InterruptedException`.

  If this thread is blocked in an I/O operation upon an ``interruptible channel`` then the channel will be closed, the thread's interrupt status will be set, and the thread will receive a `ClosedByInterruptException`.

  If this thread is blocked in a `Selector` then the thread's interrupt status will be set and it will return immediately from the selection operation, possibly with a non-zero value, just as if the selector's `wakeup` method were invoked.

  If none of the previous conditions hold then this thread's interrupt status will be set.

  Throws:
    `SecurityException` - if the current thread cannot modify this thread

### interrupted

    public static boolean interrupted()

  Tests whether the current thread has been interrupted. The interrupted status of the thread is cleared by this method. In other words, if this method were to be called twice in succession, the second call would return false (unless the current thread were interrupted again, after the first call had cleared its interrupted status and before the second call had examined it).

  Returns:
    `true` if the current thread has been interrupted; `false` otherwise.
  See Also:
    `isInterrupted()`

### isInterrupted

    public boolean isInterrupted()

  Tests whether this thread has been interrupted. The interrupted status of the thread is unaffected by this method.

  Returns:
    `true` if this thread has been interrupted; `false` otherwise.
  See Also:
    `interrupted()`

### destroy

    public void destroy()

  Destroys this thread, without any cleanup. Any monitors it has locked remain locked. (This method is not implemented.)

### isAlive

    public final boolean isAlive()

  Tests if this thread is alive. A thread is alive if it has been started and has not yet died.

  Returns:
    `true` if this thread is alive; `false` otherwise.

### suspend

    public final void suspend()

  Deprecated. This method has been deprecated, as it is inherently deadlock-prone. If the target thread holds a lock on the monitor protecting a critical system resource when it is suspended, no thread can access this resource until the target thread is resumed. If the thread that would resume the target thread attempts to lock this monitor prior to calling `resume`, deadlock results. Such deadlocks typically manifest themselves as "frozen" processes. For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.

  Suspends this thread.

  First, the `checkAccess` method of this thread is called with no arguments. This may result in throwing a `SecurityException` (in the current thread).

  If the thread is alive, it is suspended and makes no further progress unless and until it is resumed.

  Throws:
    `SecurityException` - if the current thread cannot modify this thread.
  See Also:
    `checkAccess()`

### resume

    public final void resume()

  Deprecated. This method exists solely for use with `suspend()`, which has been deprecated because it is deadlock-prone. For more information, see Why are Thread.stop, Thread.suspend and Thread.resume Deprecated?.

  Resumes a suspended thread.

  First, the `checkAccess` method of this thread is called with no arguments. This may result in throwing a `SecurityException` (in the current thread).

  If the thread is alive but suspended, it is resumed and is permitted to make progress in its execution.

  Throws:
    `SecurityException` - if the current thread cannot modify this thread.
  See Also:
    `checkAccess()`, `suspend()`

### setPriority

    public final void setPriority(int newPriority)

  Changes the priority of this thread.

  First the `checkAccess` method of this thread is called with no arguments. This may result in throwing a `SecurityException`.

  Otherwise, the priority of this thread is set to the smaller of the specified `newPriority` and the maximum permitted priority of the thread's thread group.

  Parameters:
    `newPriority` - priority to set this thread to
  Throws:
    `IllegalArgumentException` - If the priority is not in the range `MIN_PRIORITY` to `MAX_PRIORITY`.
    `SecurityException` - if the current thread cannot modify this thread.
  See Also:
    `getPriority()`, `checkAccess()`, `getPriority()`, `getThreadGroup()`, `MAX_PRIORITY`, `MIN_PRIORITY`, `ThreadGroup.getMaxPriority()`

### getPriority

    public final int getPriority()

  Returns this thread's priority.

  Returns:
    this thread's priority.
  See Also:
    `setPriority(int)`, `setPriority(int)`

### setName

    public final void setName(String name)

  Changes the name of this thread to be equal to the argument `name`.

  First the `checkAccess` method of this thread is called with no arguments. This may result in throwing a `SecurityException`.

  Parameters:
    `name` - the new name for this thread.
  Throws:
    `SecurityException` - if the current thread cannot modify this thread.
  See Also:
    `getName()`, `checkAccess()`, `getName()`

### getName

    public final String getName()

  Returns this thread's name.

  Returns:
    this thread's name.
  See Also:
    `setName(java.lang.String)`, `setName(java.lang.String)`

### getThreadGroup

    public final ThreadGroup getThreadGroup()

  Returns the thread group to which this thread belongs. This method returns null if this thread has died (been stopped).

  Returns:
    this thread's thread group.

### activeCount

    public static int activeCount()

  Returns the number of active threads in the current thread's thread group.

  Returns:
    the number of active threads in the current thread's thread group.

### enumerate

    public static int enumerate(Thread[] tarray)

  Copies into the specified array every active thread in the current thread's thread group and its subgroups. This method simply calls the `enumerate` method of the current thread's thread group with the array argument.

  First, if there is a security manager, that `enumerate` method calls the security manager's `checkAccess` method with the thread group as its argument. This may result in throwing a `SecurityException`.

  Parameters:
    `tarray` - an array of Thread objects to copy to
  Returns:
    the number of threads put into the array
  Throws:
    `SecurityException` - if a security manager exists and its `checkAccess` method doesn't allow the operation.
  See Also:
    `ThreadGroup.enumerate(java.lang.Thread[])`, `SecurityManager.checkAccess(java.lang.ThreadGroup)`

### countStackFrames

    public int countStackFrames()

  Deprecated. The definition of this call depends on `suspend()`, which is deprecated. Further, the results of this call were never well-defined.

  Counts the number of stack frames in this thread. The thread must be suspended.

  Returns:
    the number of stack frames in this thread.
  Throws:
    `IllegalThreadStateException` - if this thread is not suspended.

### join

    public final void join(long millis)
                    throws InterruptedException

  Waits at most `millis` milliseconds for this thread to die. A timeout of `0` means to wait forever.

  Parameters:
    `millis` - the time to wait in milliseconds.
  Throws:
    `InterruptedException` - if another thread has interrupted the current thread. The interrupted status of the current thread is cleared when this exception is thrown.

### join

    public final void join(long millis,
                           int nanos)
                    throws InterruptedException

  Waits at most `millis` milliseconds plus `nanos` nanoseconds for this thread to die.

  Parameters:
    `millis` - the time to wait in milliseconds.
    `nanos` - 0-999999 additional nanoseconds to wait.
  Throws:
    `IllegalArgumentException` - if the value of millis is negative the value of nanos is not in the range 0-999999.
    `InterruptedException` - if another thread has interrupted the current thread. The interrupted status of the current thread is cleared when this exception is thrown.

### join

    public final void join()
                    throws InterruptedException

  Waits for this thread to die.

  Throws:
    `InterruptedException` - if another thread has interrupted the current thread. The interrupted status of the current thread is cleared when this exception is thrown.

### dumpStack

    public static void dumpStack()

  Prints a stack trace of the current thread. This method is used only for debugging.

  See Also:
    `Throwable.printStackTrace()`

### setDaemon

    public final void setDaemon(boolean on)

  Marks this thread as either a daemon thread or a user thread. The Java Virtual Machine exits when the only threads running are all daemon threads.

  This method must be called before the thread is started.

  This method first calls the `checkAccess` method of this thread with no arguments. This may result in throwing a `SecurityException` (in the current thread).

  Parameters:
    `on` - if `true`, marks this thread as a daemon thread.
  Throws:
    `IllegalThreadStateException` - if this thread is active.
    `SecurityException` - if the current thread cannot modify this thread.
  See Also:
    `isDaemon()`, `checkAccess()`

### isDaemon

    public final boolean isDaemon()

  Tests if this thread is a daemon thread.

  Returns:
    `true` if this thread is a daemon thread; `false` otherwise.
  See Also:
    `setDaemon(boolean)`

### checkAccess

    public final void checkAccess()

  Determines if the currently running thread has permission to modify this thread.

  If there is a security manager, its `checkAccess` method is called with this thread as its argument. This may result in throwing a `SecurityException`.

  Note: This method was mistakenly non-final in JDK 1.1. It has been made final in the Java 2 Platform.

  Throws:
    `SecurityException` - if the current thread is not allowed to access this thread.
  See Also:
    `SecurityManager.checkAccess(java.lang.Thread)`

### toString

    public String toString()

  Returns a string representation of this thread, including the thread's name, priority, and thread group.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this thread.

### getContextClassLoader

    public ClassLoader getContextClassLoader()

  Returns the context ClassLoader for this Thread. The context ClassLoader is provided by the creator of the thread for use by code running in this thread when loading classes and resources. If not set, the default is the ClassLoader context of the parent Thread. The context ClassLoader of the primordial thread is typically set to the class loader used to load the application.

  First, if there is a security manager, and the caller's class loader is not null and the caller's class loader is not the same as or an ancestor of the context class loader for the thread whose context class loader is being requested, then the security manager's `checkPermission` method is called with a `RuntimePermission("getClassLoader")` permission to see if it's ok to get the context ClassLoader..

  Returns:
    the context ClassLoader for this Thread
  Throws:
    `SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow getting the context ClassLoader.
  Since:
    1.2
See Also:
  `setContextClassLoader(java.lang.ClassLoader)`, `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### setContextClassLoader

    public void setContextClassLoader(ClassLoader cl)

  Sets the context ClassLoader for this Thread. The context ClassLoader can be set when a thread is created, and allows the creator of the thread to provide the appropriate class loader to code running in the thread when loading classes and resources.

  First, if there is a security manager, its `checkPermission` method is called with a `RuntimePermission("setContextClassLoader")` permission to see if it's ok to set the context ClassLoader..

  Parameters:
    `cl` - the context ClassLoader for this Thread
  Throws:
    `SecurityException` - if the current thread cannot set the context ClassLoader.
  Since:
    1.2
See Also:
  `getContextClassLoader()`, `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### holdsLock

    public static boolean holdsLock(Object obj)

  Returns `true` if and only if the current thread holds the monitor lock on the specified object.

  This method is designed to allow a program to assert that the current thread already holds a specified lock:

           assert Thread.holdsLock(obj);

  Parameters:
    `obj` - the object on which to test lock ownership
  Returns:
    `true` if the current thread holds the monitor lock on the specified object.
  Throws:
    `NullPointerException` - if obj is `null`
  Since:
    1.4

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.